######################################################
# WindropClan @ http://windrop.clan.su 
# : Dominion 
# : 3.0
######################################################


#  
#bind pub -|- !		::ymhuk::news.pub
#bind pub -|- !			::ymhuk::news.pub
#bind pub -|- !yjdjcnb		::ymhuk::news.pub
#bind pub -|- !news			::ymhuk::news.pub

# 
#bind msg -|- !	 	::ymhuk::news.read
#bind pub -|- !yjdjcnb		::ymhuk::news.read
#bind msg -|- !new	 		::ymhuk::news.read
#bind msg -|- ! 			::ymhuk::news.read

# ()
#bind pub -|- !		::ymhuk::news.add.pub
#bind pub -|- !newsadd		::ymhuk::news.add.pub

# ()
#bind msg -|- !		::ymhuk::news.add.msg
#bind msg -|- !newsadd		::ymhuk::news.add.msg

# ()
#bind pub -|- !		::ymhuk::news.del.pub
#bind pub -|- !newsdel		::ymhuk::news.del.pub

# ()
#bind msg -|- !		::ymhuk::news.del.msg
#bind msg -|- !newsdel		::ymhuk::news.del.msg

# - 
proc ::ymhuk::news.count {} {
	variable conf
	set news [open $conf(news.base) r]
	fconfigure $news -encoding "cp1251"
	set news_length [llength [split [read $news] "\n"]]
	close $news
	return $news_length
}

#     
proc ::ymhuk::news.on.join {nick} {
	variable conf; variable ymhuk

	set news_count [expr [::ymhuk::news.count] - 1]
	if {(![validuser $nick]) || ($news_count == 0)} {return}
	if {[getuser $nick xtra news] >= $news_count} {
		setuser $nick xtra news $news_count
		return
	}
	if {[getuser $nick xtra news] == ""} {
		::ymhuk::priv.msg $nick [format [subst $ymhuk(news.new.str)] $news_count]
		::ymhuk::priv.msg $nick [format $ymhuk(news.read.str) $news_count]
		return
	}
	if {[getuser $nick xtra news] != ""} {
		::ymhuk::priv.msg $nick [format [subst $ymhuk(news.new.str1)] [expr $news_count - [getuser $nick xtra news]] [getuser $nick xtra news]]
		::ymhuk::priv.msg $nick [format $ymhuk(news.read.str) $news_count]
		return
	}
	return
}

# 
proc ::ymhuk::news.read {nick uhost handle text} {
	variable conf; variable ymhuk
	if {![validuser $nick]} {
		::ymhuk::priv.msg $nick $ymhuk(news.unknown.str)
		return
	}
	if {($text < 1) || ($text > [expr [::ymhuk::news.count] - 1]) || ($text == "")} {
		::ymhuk::priv.msg $nick [format $ymhuk(news.no.new.str) [expr [::ymhuk::news.count] - 1]] 
		return
	}
	set news [open $conf(news.base) r]
	fconfigure $news -encoding "cp1251"
	set new [lindex [split [read $news] "\n"] [expr $text - 1]]
	close $news
	set new [split $new "&"]
	set date [lindex $new 0]
	set line_new [lindex $new 1]
	set nick_new [lindex $new 2]
	if {[getuser $nick xtra news] < $text} {
		setuser $nick xtra news $text
	}
	::ymhuk::priv.msg $nick [format $ymhuk(news.read.str1) $text $date $line_new $nick_new]
	return
}

# 
proc ::ymhuk::news.add.pub {nick uhost handle chan text} {
	variable conf; variable ymhuk
	if {[string tolower $chan] != [string tolower $conf(chan)]} {
		return
	}
	if {![isop $nick $chan]} {
		::ymhuk::pub.msg [format $ymhuk(news.no.op.str) $nick]
		return
	}
	set ymhuk(news.add.msg) 0
	::ymhuk::news.add $nick $uhost $handle $chan $text
	return
}

# 
proc ::ymhuk::news.add.msg {nick uhost handle text} {
	variable conf; variable ymhuk
	if {![isop $nick $conf(chan)]} {
		::ymhuk::priv.msg $nick [format $ymhuk(news.no.op.str1) $conf(chan)]
		return
	}
	set ymhuk(news.add.msg) 1
	::ymhuk::news.add $nick $uhost $handle 0 $text
	return
}

# 
proc ::ymhuk::news.add {nick uhost handle chan text} {
	variable conf; variable ymhuk
	set news [open $conf(news.base) a]
	fconfigure $news -encoding "cp1251"
	puts $news "[strftime "%d %h %Y" [unixtime]]&$text&$nick"
	close $news
	if {$conf(show.new.news) == 1} {
		foreach user [chanlist $conf(chan)] {
			if {([string match $user $nick]) || ([isbotnick $user])} {continue}
			::ymhuk::priv.msg $user [format $ymhuk(news.add.str) [expr [::ymhuk::news.count] - 1] [expr [::ymhuk::news.count] - 1]]
		}
	}
	switch $ymhuk(news.add.msg) {
	1 { ::ymhuk::priv.msg $nick [format $ymhuk(news.add.str1) [expr [::ymhuk::news.count] - 1]] }
	0 {	::ymhuk::pub.msg [format $ymhuk(news.add.str1) [expr [::ymhuk::news.count] - 1]] }
	}
	return
}

# 
proc ::ymhuk::news.del.pub {nick uhost handle chan text} {
	variable conf; variable ymhuk
		if {[string tolower $chan] != [string tolower $conf(chan)]} {
		return
	}
	if {![isop $nick $chan]} {
		::ymhuk::pub.msg [format $ymhuk(news.no.op.str) $nick]
		return
	}
	if {($text > [expr [::ymhuk::news.count] - 1]) || ($text < 1)} {
		::ymhuk::pub.msg [format $ymhuk(news.del.str) [expr [::ymhuk::news.count] - 1]]
		return
	}
	set ymhuk(news.del.msg) 0
	::ymhuk::news.del $nick $uhost $handle $chan $text
	return
}

# 
proc ::ymhuk::news.del.msg {nick uhost handle text} {
	variable conf; variable ymhuk
	if {![isop $nick $conf(chan)]} {
		::ymhuk::priv.msg $nick [format $ymhuk(news.no.op.str2) $nick $conf(chan)]
		return
	}
	if {($text > [expr [::ymhuk::news.count] - 1]) || ($text < 1)} {
		::ymhuk::priv.msg [format $ymhuk(news.del.str) [expr [::ymhuk::news.count] - 1]]
		return
	}
	set ymhuk(news.del.msg) 1
	::ymhuk::news.del $nick $uhost $handle 0 $text
	return
}

# 
proc ::ymhuk::news.del {nick uhost handle chan text} {
	variable conf; variable ymhuk
	set news [open $conf(news.base) r]
	fconfigure $news -encoding "cp1251"
	set lst [split [read $news] "\n"]
	close $news
	set lst [lreplace $lst [expr $text - 1] [expr $text - 1]]
	set news [open $conf(news.base) w+]
	fconfigure $news -encoding "cp1251"
	foreach item $lst {
		if {![llength $item]} {continue} else {puts $news "$item"}
	}
	close $news
	switch $ymhuk(news.del.msg) {
		1 { ::ymhuk::priv.msg $nick [format $ymhuk(news.del.str1) $text] }
		0 {	::ymhuk::pub.msg [format $ymhuk(news.del.str1) $text] }	
	}
	return
}

#   
proc ::ymhuk::news.pub {nick uhost handle chan text} {
	variable conf; variable ymhuk
		variable conf; variable ymhuk
		if {[string tolower $chan] != [string tolower $conf(chan)]} {
		return
	}
	::ymhuk::pub.msg [format $ymhuk(news.all.str) [expr [::ymhuk::news.count] - 1]]
	return
}