######################################################
# WindropClan @ http://windrop.clan.su
# : Dominion 
# : 3.0
######################################################

###########################################

package require mysqltcl

###########################################

bind dcc n createdb		::ymhuk::create.db
bind dcc n importcounters	::ymhuk::import.counters

bind dcc -|- questionstosql	::ymhuk::questions.convert.to.sql
bind dcc -|- showquestion	::ymhuk::show.question
bind dcc -|- delquestion	::ymhuk::del.question
bind dcc -|- addquestion	::ymhuk::add.question
bind dcc -|- updatequestion	::ymhuk::update.question

bind dcc -|- anagrammstosql	::ymhuk::anagramms.convert.to.sql
bind dcc -|- showanagramm	::ymhuk::show.anagramm
bind dcc -|- delanagramm	::ymhuk::del.anagramm
bind dcc -|- addanagramm	::ymhuk::add.anagramm
bind dcc -|- updateanagramm	::ymhuk::update.anagramm

bind dcc -|- sharadstosql	::ymhuk::sharads.convert.to.sql
bind dcc -|- showsharad		::ymhuk::show.sharad
bind dcc -|- delsharad		::ymhuk::del.sharad
bind dcc -|- addsharad		::ymhuk::add.sharad
bind dcc -|- updatesharad	::ymhuk::update.sharad

#####################################################################
#####################################################################
#############						#############
#############						#############
#############		    mysql	#############
#############						#############
#############					        #############
#####################################################################
#####################################################################


###############################################
#########		 
###############################################

#########		   
proc ::ymhuk::sql.connect {} {
	variable conf; variable ymhuk
	putlog "   sql..."
	set ymhuk(sql.con) [::mysql::connect -host $conf(sql.host) -user $conf(sql.user) -password $conf(sql.pass) -db $conf(sql.db)]
	if {[string match "*sql*" $ymhuk(sql.con)]} {
		::mysql::use $ymhuk(sql.con) $conf(sql.db)
		mysqlexec $ymhuk(sql.con) {SET CHARACTER SET cp1251}
		putlog " .  - $ymhuk(sql.con)."
		return 1
	} else {
		putlog "\0034    sql!"
		return 0
	}
}

#########		   
proc ::ymhuk::sql.close {} {
	variable ymhuk
	putlog "\002    sql..."
	set ymhuk(sql.close) [::mysql::close $ymhuk(sql.con)]
	putlog "$ymhuk(sql.close)"
	catch {unset ymhuk(sql.con)}
	putlog "\002   sql !"
	return
}

proc ymhuk::sql.chk {} {
	variable conf ; variable ymhuk
	set ymhuk(sql.con) [::mysql::connect -host $conf(sql.host) -user $conf(sql.user) -password $conf(sql.pass) -db $conf(sql.db)]
	mysqlexec $ymhuk(sql.con) {SET CHARACTER SET cp1251}
	return $ymhuk(sql.con)
	}

proc ::ymhuk::sql.ping {} {
	variable conf ; variable ymhuk
	if {![info exists ymhuk(sql.con)]} {ymhuk::sql.chk}
	if {![mysqlping $ymhuk(sql.con)]} {set ymhuk(sql.con) [ymhuk::sql.chk] ; return 1}
return 1
}

#########		    
proc ::ymhuk::sql.ping_ {} {
	variable conf; variable ymhuk
#	putlog "  sql..."
	if {![info exists ymhuk(sql.con)]} {
		putlog "  !"
		if {[::ymhuk::sql.connect]} {
			return 1
		} else {
			return 0
		}
	} else {
		switch "[::mysql::state $ymhuk(sql.con) -numeric]" {
			0 {
				putlog " !"
				unset ymhuk(sql.con)
				if {[::ymhuk::sql.connect]} {
					return 1
				} else {
					return 0
				}
			}
			1 {
				putlog "    !"
				if {[::mysql::ping $ymhuk(sql.con)]} {
					putlog " ."					
					return 1
				} else {
					putlog "  .  1."
					return 0
				}
			}
			2 {
				putlog "    !"
				if {[::mysql::ping $ymhuk(sql.con)]} {
					[::mysql::use $ymhuk(sql.con) $conf(sql.db)]
					putlog " ,  - $ymhuk(sql.con)."
					#putlog " sql   ."
					return 1
				} else {
					putlog "  .  2."
					return 0
				}
			}
			3 {
				if {[::mysql::ping $ymhuk(sql.con)]} {
					#putlog " sql   ."
					return 1
				} else {
					putlog "  .  3."
					return 0
				}
			}
			4 {
				if {[::mysql::ping $ymhuk(sql.con)]} {
					#putlog " sql   ."
					return 1
				} else {
					putlog "  .  4."
					return 0
				}
			}
		}
	}
	return
}

#########		    
proc ::ymhuk::sql.retry {} {
	variable conf; variable ymhuk
	if {!$ping} {
		putlog "     sql    $conf(sql.retry) ."
		utimer $conf(sql.retry) [list ::ymhuk::ping]
		return
	} 
}


###############################################
#########		  
###############################################

#########		  , , , 
proc ::ymhuk::create.db {handle idx text} {
	variable conf; variable ymhuk
	if {![info exists conf(sql.host)] && ![info exists conf(sql.user)] && ![info exists conf(sql.pass)] && ![info exists conf(sql.db)]} {
		putlog "\0034   !   .   ."
		return
	}
	if {![::ymhuk::sql.ping]} {
		putlog "\0034    !   sql."
		return
	}
	catch { 
		#::mysql::exec $ymhuk(sql.con) "drop table questions;"
		::mysql::exec $ymhuk(sql.con) "drop table anagramms;"
		::mysql::exec $ymhuk(sql.con) "drop table sharads;"
		::mysql::exec $ymhuk(sql.con) "drop table counters;"
	}
	::mysql::exec $ymhuk(sql.con) "create table if not exists questions (id int(10) not null, question text not null, answer varchar(100) not null, primary key (id));"
	putlog "\002  ."
	::mysql::exec $ymhuk(sql.con) "create table if not exists anagramms (id int(10) not null, anagramm text not null, primary key (id));"
	putlog "\002  ."
	::mysql::exec $ymhuk(sql.con) "create table if not exists sharads (id int(10) not null, sharada text not null, answer varchar(100) not null, primary key (id));"
	putlog "\002  ."
	::mysql::exec $ymhuk(sql.con) "create table if not exists counters (id int(1) not null, q_counter int(10), a_counter int(10), s_counter int(10), primary key (id));"
	::mysql::exec $ymhuk(sql.con) "insert into counters (id, q_counter, a_counter, s_counter) values (1, 1, 1, 1);"
	putlog "\002  c."
	return
}

#########		   
proc ::ymhuk::import.counters {handle idx text} {
	variable conf; variable ymhuk
	set q [getuser $conf(owner) xtra counter]
	set a [getuser $conf(owner) xtra anagramm]
	set s [getuser $conf(owner) xtra sharads]
	if {![::ymhuk::sql.ping]} {
		putlog "\0034    !   sql."
		return
	}
	::mysql::exec $ymhuk(sql.con) "update counters set q_counter = $q, a_counter = $a, s_counter = $s where id = 1;"
	putlog "\002  ."
	return
}

###############################################
#########		   
###############################################

#########		     
proc ::ymhuk::questions.convert.to.sql {handle idx text} {
	variable conf; variable ymhuk
	if {![::ymhuk::sql.ping]} {
		putlog "\0034    !   sql."
		return
	}
	set q [::mysql::query $ymhuk(sql.con) "select count(*) from questions;"]
	set count [::mysql::fetch $q]
	::mysql::endquery $q
	set j 0
	set i [expr $count + 1]
	putlog "\002    MySQL..."
	catch {open $conf(questions) r} f
	while {![eof $f]} {
		set position [tell $f]
		set line [string trim [gets $f]]
		foreach {question answer} [split $line "|"] {break}
		if {($question != "") && $answer != ""} {
			::mysql::exec $ymhuk(sql.con) "insert into questions (id, question, answer) values ($i, '[mysqlescape $question]', '[mysqlescape $answer]');"
			incr i
			incr j
		}
	}
	putlog "\002    $j .    [expr $i - 1] ."
	return
}

#########		    id
proc ::ymhuk::show.question {handle idx text} {
	variable conf; variable ymhuk
	if {[regexp -- {[^0-9]} $text]} {
		putlog "\002Id    !"
		return
	}
	if {![::ymhuk::sql.ping]} {
		putlog "\0034    !   sql."
		return
	}
	set q [::mysql::query $ymhuk(sql.con) "select * from questions where id = $text;"]
	set raw [::mysql::fetch $q]
	::mysql::endquery $q
	if {$raw == ""} {
		putlog "\002 id    !"
		return
	} else {
		putlog "\002:\017 [lindex $raw 0] | [lindex $raw 1] | [lindex $raw 2]."
		return
	}
	return
}

#########		    
proc ::ymhuk::del.question {handle idx text} {
	variable conf; variable ymhuk
	if {[regexp -- {[^0-9]} $text]} {
		putlog "\002Id    !"
		return
	}
	if {![::ymhuk::sql.ping]} {
		putlog "\0034    !   sql."
		return
	}
	set q [::mysql::query $ymhuk(sql.con) "select * from questions where id = $text;"]
	set raw [::mysql::fetch $q]
	::mysql::endquery $q
	if {$raw == ""} {
		putlog "\002 id    !"
		return
	} else {
		set q [::mysql::query $ymhuk(sql.con) "select count(*) from questions;"]
		set count [::mysql::fetch $q]
		::mysql::endquery $q
		::mysql::exec $ymhuk(sql.con) "delete from questions where id = $text;"
		putlog "\002   ."
		putlog "\002  ..."
		for {set i $text} {$i < $count} {incr i} {
			::mysql::exec $ymhuk(sql.con) "update questions set id = $i where id = [expr $i + 1];"
		}
		putlog "\002   ."
		return
	}
	return
}

#########		   
proc ::ymhuk::add.question {handle idx text} {
	variable conf; variable ymhuk
	foreach {question answer} [split $text "|"] {break}
	if {($question == "") || ($answer == "")} {
		putlog "\002  !"
		putlog "\002  \"|\"."
		return
	}
	if {![::ymhuk::sql.ping]} {
		putlog "\0034    !   sql."
		return
	}
	set q [::mysql::query $ymhuk(sql.con) "select count(*) from questions;"]
	set count [::mysql::fetch $q]
	::mysql::endquery $q
	::mysql::exec $ymhuk(sql.con) "insert into questions (id, question, answer) values ([expr $count + 1], '$question', '$answer');"
	putlog "\002   id = [expr $count + 1]."
	return
}

#########		 
proc ::ymhuk::update.question {handle idx text} {
	variable conf; variable ymhuk
	foreach {id question answer} [split $text "|"] {break}
	if {($id == "") || ($question == "") || ($answer == "")} {
		putlog "\002  !"
		putlog "\002  \"Id||\"."
		return
	}
	if {[regexp -- {[^0-9]} $id]} {
		putlog "\002Id    !"
		return
	}
	if {![::ymhuk::sql.ping]} {
		putlog "\0034    !   sql."
		return
	}
	set q [::mysql::query $ymhuk(sql.con) "select * from questions where id = $id;"]
	set raw [::mysql::fetch $q]
	::mysql::endquery $q
	if {$raw == ""} {
		putlog "\002 id    !"
		return
	} else {
		::mysql::exec $ymhuk(sql.con) "update questions set question = '$question', answer = '$answer' where id = $id;"
		putlog "\002   id = $id."
		return
	}
	return
}


###############################################
#########		   
###############################################

#########		     
proc ::ymhuk::anagramms.convert.to.sql {handle idx text} {
	variable conf; variable ymhuk
	if {![::ymhuk::sql.ping]} {
		putlog "\0034    !   sql."
		return
	}
	set q [::mysql::query $ymhuk(sql.con) "select count(*) from anagramms;"]
	set count [::mysql::fetch $q]
	::mysql::endquery $q
	set j 0
	set i [expr $count + 1]
	putlog "\002    MySQL..."
	catch {open $conf(anagramm.base) r} f
	while {![eof $f]} {
		set position [tell $f]
		set word [string trim [gets $f]]
		if {$word != ""} {
			::mysql::exec $ymhuk(sql.con) "insert into anagramms (id, anagramm) values ($i, '$word');"
			incr i
			incr j
		}
	}
	putlog "\002    $j .    [expr $i - 1] ."
	return
}

#########		    id
proc ::ymhuk::show.anagramm {handle idx text} {
	variable conf; variable ymhuk
	if {[regexp -- {[^0-9]} $text]} {
		putlog "\002Id    !"
		return
	}
	if {![::ymhuk::sql.ping]} {
		putlog "\0034    !   sql."
		return
	}
	set q [::mysql::query $ymhuk(sql.con) "select * from anagramms where id = $text;"]
	set raw [::mysql::fetch $q]
	::mysql::endquery $q
	if {$raw == ""} {
		putlog "\002 id    !"
		return
	} else {
		putlog "\002:\017 [lindex $raw 0] | [lindex $raw 1]."
		return
	}
	return
}

#########		    
proc ::ymhuk::del.anagramm {handle idx text} {
	variable conf; variable ymhuk
	if {[regexp -- {[^0-9]} $text]} {
		putlog "\002Id    !"
		return
	}
	if {![::ymhuk::sql.ping]} {
		putlog "\0034    !   sql."
		return
	}
	set q [::mysql::query $ymhuk(sql.con) "select * from anagramms where id = $text;"]
	set raw [::mysql::fetch $q]
	::mysql::endquery $q
	if {$raw == ""} {
		putlog "\002 id    !"
		return
	} else {
		set q [::mysql::query $ymhuk(sql.con) "select count(*) from anagramms;"]
		set count [::mysql::fetch $q]
		::mysql::endquery $q
		::mysql::exec $ymhuk(sql.con) "delete from anagramms where id = $text;"
		putlog "\002   "
		putlog "\002  ..."
		for {set i $text} {$i < $count} {incr i} {
			::mysql::exec $ymhuk(sql.con) "update anagramms set id = $i where id = [expr $i + 1];"
		}
		putlog "\002   ."
		return
	}
	return
}

#########		   
proc ::ymhuk::add.anagramm {handle idx text} {
	variable conf; variable ymhuk
	regsub -all -- { } $text "" text
	if {$text == ""} {
		putlog "\002  !"
		putlog "\002  \"\"."
		return
	}
	if {![::ymhuk::sql.ping]} {
		putlog "\0034    !   sql."
		return
	}
	set q [::mysql::query $ymhuk(sql.con) "select count(*) from anagramms;"]
	set count [::mysql::fetch $q]
	::mysql::endquery $q
	::mysql::exec $ymhuk(sql.con) "insert into anagramms (id, anagramm) values ([expr $count + 1], '$text');"
	putlog "\002   id = [expr $count + 1]."
	return
}

#########		 
proc ::ymhuk::update.anagramm {handle idx text} {
	variable conf; variable ymhuk
	regsub -all -- { } $text "" text
	if {$text == ""} {
		putlog "\002  !"
		putlog "\002  \"Id|\"."
		return
	}
	foreach {id word} [split $text "|"] {break}
	if {($id == "") || ($word == "")} {
		putlog "\002  !"
		putlog "\002  \"Id|\"."
		return
	}
	if {[regexp -- {[^0-9]} $id]} {
		putlog "\002Id    !"
		return
	}
	if {![::ymhuk::sql.ping]} {
		putlog "\0034    !   sql."
		return
	}
	set q [::mysql::query $ymhuk(sql.con) "select * from anagramms where id = $id;"]
	set raw [::mysql::fetch $q]
	::mysql::endquery $q
	if {$raw == ""} {
		putlog "\002 id    !"
		return
	} else {
		::mysql::exec $ymhuk(sql.con) "update anagramms set anagramm = '$word' where id = $id;"
		putlog "\002   id = $id."
		return
	}
	return
}


###############################################
#########		   
###############################################

#########		     
proc ::ymhuk::sharads.convert.to.sql {handle idx text} {
	variable conf; variable ymhuk
	if {![::ymhuk::sql.ping]} {
		putlog "\0034    !   sql."
		return
	}
	set q [::mysql::query $ymhuk(sql.con) "select count(*) from sharads;"]
	set count [::mysql::fetch $q]
	::mysql::endquery $q
	set j 0
	set i [expr $count + 1]
	putlog "\002    MySQL..."
	catch {open $conf(sharads.base) r} f
	while {![eof $f]} {
		set position [tell $f]
		set line [string trim [gets $f]]
		foreach {question answer} [split $line "|"] {break}
		if {($question != "") && $answer != ""} {
			::mysql::exec $ymhuk(sql.con) "insert into sharads (id, sharada, answer) values ($i, '$question', '$answer');"
			incr i
			incr j
		}
	}
	putlog "\002    $j .    [expr $i - 1] ."
	return
}

#########		    id
proc ::ymhuk::show.sharad {handle idx text} {
	variable conf; variable ymhuk
	if {[regexp -- {[^0-9]} $text]} {
		putlog "\002Id    !"
		return
	}
	if {![::ymhuk::sql.ping]} {
		putlog "\0034    !   sql."
		return
	}
	set q [::mysql::query $ymhuk(sql.con) "select * from sharads where id = $text;"]
	set raw [::mysql::fetch $q]
	::mysql::endquery $q
	if {$raw == ""} {
		putlog "\002 id    !"
		return
	} else {
		putlog "\002:\017 [lindex $raw 0] | [lindex $raw 1] | [lindex $raw 2]."
		return
	}
	return
}

#########		    
proc ::ymhuk::del.sharad {handle idx text} {
	variable conf; variable ymhuk
	if {[regexp -- {[^0-9]} $text]} {
		putlog "\002Id    !"
		return
	}
	if {![::ymhuk::sql.ping]} {
		putlog "\0034    !   sql."
		return
	}
	set q [::mysql::query $ymhuk(sql.con) "select * from sharads where id = $text;"]
	set raw [::mysql::fetch $q]
	::mysql::endquery $q
	if {$raw == ""} {
		putlog "\002 id    !"
		return
	} else {
		set q [::mysql::query $ymhuk(sql.con) "select count(*) from sharads;"]
		set count [::mysql::fetch $q]
		::mysql::endquery $q
		::mysql::exec $ymhuk(sql.con) "delete from sharads where id = $text;"
		putlog "\002   ."
		putlog "\002  ..."
		for {set i $text} {$i < $count} {incr i} {
			::mysql::exec $ymhuk(sql.con) "update sharads set id = $i where id = [expr $i + 1];"
		}
		putlog "\002   ."
		return
	}
	return
}

#########		   
proc ::ymhuk::add.sharad {handle idx text} {
	variable conf; variable ymhuk
	foreach {question answer} [split $text "|"] {break}
	if {($question == "") || ($answer == "")} {
		putlog "\002  !"
		putlog "\002  \"1*2*...*N|\"."
		return
	}
	if {![::ymhuk::sql.ping]} {
		putlog "\0034    !   sql."
		return
	}
	set q [::mysql::query $ymhuk(sql.con) "select count(*) from sharads;"]
	set count [::mysql::fetch $q]
	::mysql::endquery $q
	::mysql::exec $ymhuk(sql.con) "insert into sharads (id, sharada, answer) values ([expr $count + 1], '$question', '$answer');"
	putlog "\002   id = [expr $count + 1]."
	return
}

#########		 
proc ::ymhuk::update.sharad {handle idx text} {
	variable conf; variable ymhuk
	foreach {id question answer} [split $text "|"] {break}
	if {($id == "") || ($question == "") || ($answer == "")} {
		putlog "\002  !"
		putlog "\002  \"Id|1*2*...*N|\"."
		return
	}
	if {[regexp -- {[^0-9]} $id]} {
		putlog "\002Id    !"
		return
	}
	if {![::ymhuk::sql.ping]} {
		putlog "\0034    !   sql."
		return
	}
	set q [::mysql::query $ymhuk(sql.con) "select * from sharads where id = $id;"]
	set raw [::mysql::fetch $q]
	::mysql::endquery $q
	if {$raw == ""} {
		putlog "\002 id    !"
		return
	} else {
		::mysql::exec $ymhuk(sql.con) "update sharads set sharada = '$question', answer = '$answer' where id = $id;"
		putlog "\002   id = $id."
		return
	}
	return
}
