####################################################################################################
##     
####################################################################################################
#   :
#	v1.4.1
# -   !info        
#	v1.3.1
# -   !info      
#	v1.2.7
# -   !info   
#	v1.2.6
# -   !info      
#	v1.2.5
# -   { }      !whois

if {[namespace current] == "::"} {putlog "\002\00304You shouldn't use source for [info script]"; return}

set _name	{base}
pkg_add mod $_name "Buster <buster@buster-net.ru> (c)" "1.4.1" "03-Jun-2010" \
	"        ."

if {[pkg_info mod $_name on]} {
	
	################################################################################################
	#       . (0 - , 1 - ).
	#        ccs-vkickuser
	set options(vkickuser)			0
	
	################################################################################################
	#       . (0 - , 1 - ).
	#        ccs-vtopicuser
	set options(vtopicuser)			1
	
	cmd_configure kick -control -group "mode" -flags {o|o} -block 1 \
		-alias {%pref_kick} \
		-regexp {{^([^\ ]+)(?:\ +(.*?))?$} {-> dnick reason}}
	
	cmd_configure inv -control -group "other" -flags {m|m} -block 5 \
		-alias {%pref_inv} \
		-regexp {{^([^\ ]+)$} {-> dnick}}
	
	cmd_configure topic -control -group "chan" -flags {o|o T|T} -block 3 \
		-alias {%pref_topic} \
		-regexp {{^(.+?)$} {-> stext}}
	
	cmd_configure addtopic -control -group "chan" -flags {o|o T|T} -block 5 \
		-alias {%pref_addtopic %pref_} \
		-regexp {{^(.+?)$} {-> stext}}
	
	cmd_configure ops -control -group "info" -flags {-|-} -block 5 -use_auth 0 -use_botnet 0 \
		-alias {%pref_ops} \
		-regexp {{^$} {}}
	
	cmd_configure admins -control -group "info" -flags {-|-} -block 5 -use_auth 0 -use_chan 0 -use_botnet 0 \
		-alias {%pref_admins} \
		-regexp {{^$} {}}
	
	cmd_configure whom -control -group "info" -flags {p} -block 5 -use_auth 0 -use_chan 0 -use_botnet 0 \
		-alias {%pref_whom} \
		-regexp {{^$} {}}
	
	cmd_configure whois -control -group "user" -flags {%v} -block 2 -use_auth 0 -use_chan 3 \
		-alias {%pref_whois} \
		-regexp {{^([^\ ]+)?$} {-> dnick}}
	
	cmd_configure info -control -group "info" -flags {-|-} -block 5 -use_auth 0 -use_chan 0 \
		-alias {%pref_info %pref_} \
		-regexp {{^(?:()(?:\s+([a-zA-Z]))?)?$} {-> dname dflag}}
	
	setudef str ccs-vkickuser
	setudef str ccs-vtopicuser
	
	################################################################################################
	#    (KICK).
	
	proc cmd_kick {} {
		upvar out out
		importvars [list snick shand schan command dnick reason]
		
		if {$reason == ""} {set reason [sprintf base #101]}
		foreach _ [split $dnick ,] {
			set dhand [nick2hand $_]
			if {[check_notavailable {-isbotnick -notonchan -protect -nopermition0} -shand $shand -dnick $_ -dhand $dhand -dchan $schan]} {continue}
			
			if {[get_options "vkickuser" $schan]} {append reason " \($shand\)"}
			
			if {[botisop $schan] || [botishalfop $schan]} {putkick $schan $_ $reason}
			put_log "$_ ($reason)."
		}
		return 1
		
	}
	
	################################################################################################
	#     (INVITE).
	
	proc cmd_inv {} {
		upvar out out
		importvars [list snick shand schan command dnick]
		
		if {[check_notavailable {-onchan} -dnick $dnick -dchan $schan]} {return 0}
		
		putserv "INVITE $dnick $schan"
		put_log "$dnick"
		return 1
		
	}
	
	################################################################################################
	#     (TOPIC).
	
	proc cmd_topic {} {
		upvar out out
		importvars [list snick shand schan command stext]
		
		if {[get_options "vtopicuser" $schan]} {append stext " \($shand\)"}
		putserv "TOPIC $schan :[sprintf base #102 $stext]"
		put_log "($stext)"
		return 1
		
	}
	
	proc cmd_addtopic {} {
		upvar out out
		importvars [list snick shand schan command stext]
		
		if {[get_options "vtopicuser" $schan]} {append stext " \($shand\)"}
		putserv "TOPIC $schan :[sprintf base #103 [topic $schan] $stext]"
		put_log "($stext)"
		return 1
		
	}
	
	################################################################################################
	#     .
	
	proc own_list {data} {
		
		set outstring [list]
		foreach n $data {lappend outstring [StrNick -hand $n]}
		return [join $outstring ", "]
		
	}
	
	proc cmd_ops {} {
		upvar out out
		importvars [list snick shand schan command]
		
		put_msg -speed 3 -- [sprintf base #107 $schan]
		foreach {t f} {#108 f #109 l #110 o #111 m #112 n} {
			put_msg -speed 3 -- [sprintf base $t [own_list [userlist -|$f $schan]]]
		}
		put_log ""
		return 1
		
	}
	
	proc cmd_admins {} {
		upvar out out
		importvars [list snick shand schan command]
		global botnick admin
		if {$admin == ""} {set admin [lindex [split $::owner ", "] 0]}
		put_msg -speed 3 -- [sprintf base #113 $botnick]
		foreach {t f} {#114 f #115 l #116 o #117 m #118 n} {
			put_msg -speed 3 -- [sprintf base $t [own_list [userlist $f]]]
		}
		put_msg -speed 3 -- [sprintf base #119 $admin]
		put_log ""
		return 1
		
	}
	
	################################################################################################
	#     (DCC Chat).
	
	proc cmd_whom {} {
		upvar out out
		importvars [list snick shand schan command]
		
		set p_t [whom *]
		if {[llength $p_t] == 0} {put_msg [sprintf base #120]; return 0}
		
		put_msg -speed 3 -- [sprintf base #121]
		foreach _ $p_t {
			lassign $_ fnick fbot fhostname fflag fidle faway fchan
			if {$fidle == "" || $fidle == 0} {
				put_msg -speed 3 -- [sprintf base #122 $fnick $fbot $fhostname]
			} else {
				put_msg -speed 3 -- [sprintf base #123 $fnick $fbot $fhostname [xdate [duration [expr ($fidle * 60)]]]]
			}
		}
		put_msg -speed 3 -- [sprintf base #124]
		put_log ""
		return 1
		
	}
	
	################################################################################################
	#     (USER).
	
	proc cmd_whois {} {
		upvar out out
		importvars [list snick shand schan command dnick]
		
		if {[string is space $dnick]} {set dnick $snick}
		
		if {[onchan $dnick]} {
			if {[check_isnull [set dhand [nick2hand $dnick]]]} {
				if {[validuser $dnick]} {
					#           
					put_msgwhois [hand2nick $dnick] $dnick $schan
				} else {
					#     
					put_msg [sprintf ccs #123 $dnick]
					return 0
				}
			} else {
				if {![string equal -nocase $dnick $dhand] && [validuser $dnick]} {
					#              
					put_msgwhois $dnick $dhand $schan
					put_msgwhois [hand2nick $dnick] $dnick $schan
				} else {
					#             
					put_msgwhois $dnick $dhand $schan
				}
			}
			
		} else {
			if {[validuser $dnick]} {
				#     (       )
				put_msgwhois [hand2nick $dnick] $dnick $schan
			} else {
				#         
				put_msg [sprintf ccs #125 $dnick]
				return 0
			}
		}
		return 1
		
	}
	
	proc put_msgwhois {dnick dhand schan} {
		variable options
		upvar out out
		
		put_msg "[expr {![check_isnull $dnick] ? "nick \002$dnick\002, " : ""}]handle \002$dhand\002. [sprintf base #125 [chattr $dhand $schan] [join [getuser $dhand HOSTS]] [expr {[string is space [set info [getchaninfo $dhand $schan]]] ? "" : " INFO: $info."}]]"
		
		set lauth [list]
		if {[matchattr $dhand $options(flag_auth_perm)]} {
			lappend lauth [sprintf base #129]
		} elseif {[matchattr $dhand $options(flag_auth)] || [matchattr $dhand $options(flag_auth_botnet)]} {
			if {[matchattr $dhand $options(flag_auth)]} {
				lappend lauth [sprintf base #127 [join [getuser $dhand XTRA AuthNick] ", "]]
			}
			if {[matchattr $dhand $options(flag_auth_botnet)]} {
				lappend lauth [sprintf base #126 [join [getuser $dhand XTRA AuthBot] ", "]]
			}
		} else {lappend lauth [sprintf base #128]}
		put_msg [sprintf base #132 [join $lauth ", "]]
		
		if {[matchattr $dhand b]} {
			set o_botaddr [getuser $dhand BOTADDR]
			put_msg [sprintf base #130 $dhand [botattr $dhand] [expr {[islinked $dhand] ? "yes" : "no"}] [lindex $o_botaddr 0] [lindex $o_botaddr 1] [lindex $o_botaddr 2]]
		}
		
	}
	
proc cmd_info {} {
upvar out out
importvars [list snick shand schan command dname dflag]
variable author
variable version
variable date
variable options
switch -exact -- $dname {

 {
switch -exact -- $dflag {
n {put_msg [sprintf base #151]}
m {put_msg [sprintf base #152]}
t {put_msg [sprintf base #153]}
a {put_msg [sprintf base #154]}
o {put_msg [sprintf base #155]}
y {put_msg [sprintf base #156]}
l {put_msg [sprintf base #157]}
g {put_msg [sprintf base #158]}
v {put_msg [sprintf base #159]}
f {put_msg [sprintf base #160]}
p {put_msg [sprintf base #161]}
q {put_msg [sprintf base #162]}
r {put_msg [sprintf base #163]}
d {put_msg [sprintf base #164]}
k {put_msg [sprintf base #165]}
x {put_msg [sprintf base #166]}
j {put_msg [sprintf base #167]}
c {put_msg [sprintf base #168]}
w {put_msg [sprintf base #169]}
z {put_msg [sprintf base #170]}
e {put_msg [sprintf base #171]}
u {put_msg [sprintf base #172]}
h {put_msg [sprintf base #173]}
b {put_msg [sprintf base #174]}
default {
if {$dflag == $options(flag_auth)} {put_msg [sprintf base #175 $options(flag_auth)]
} elseif {$dflag == $options(flag_auth_botnet)} {put_msg [sprintf base #176 $options(flag_auth_botnet)]
} elseif {$dflag == $options(flag_botnet_check)} {put_msg [sprintf base #177 $options(flag_botnet_check)]
} elseif {$dflag == $options(flag_auth_perm)} {put_msg [sprintf base #178 $options(flag_auth_perm)]
} elseif {$dflag == $options(flag_locked)} {put_msg [sprintf base #179 $options(flag_locked)]
} elseif {$dflag == [string range $options(flag_protect) 0 0]} {put_msg [sprintf base #180 $options(flag_protect)]
} elseif {$dflag == $options(flag_cmd_bot)} {put_msg [sprintf base #181 $options(flag_cmd_bot)]
} else {put_msg [sprintf base #182 $dflag]}
}
}
}

default {
if {[string match -nocase *CYGWIN* [unames]]} {set lfirst "WinDrop"} {set lfirst "WPack"}                   
set lout "$lfirst 2.0 $::gcolor(12)http://windrop.clan.su\017 :: : \002$::owner\002; : \002[countusers]\002;   : \002[string map -nocase {"  " " " Mon  Tue  Wed  Thu  Fri  Sat  Sun  Jan  Feb  Mar  Apr  May  Jun  Jul  Aug  Sep  Oct  Nov  Dec } [strftime "%a %e %b %Y - %X"]]\002; : \002[unames]\002; eggdrop: \002[lindex [split $::version] 0]\002; tcl: \002[info pa]\002."
put_msg -speed 3 -- $lout; set lout ""
if {[string match -nocase *CYGWIN* [unames]]} {set lfirst ""} {set lfirst ""
append lout "  [string map -nocase {"  " " " Mon " " Tue " " Wed " " Thu " " Fri " " Sat " " Sun " " Jan  Feb  Mar  Apr  May  Jun  Jul  Aug  Sep  Oct  Nov  Dec } [clock format [file mtime eggdrop] -format "%a %e %b %Y"]]"
set meminf "n/a"; catch {regexp -nocase -- {Mem:\s+\d+\s+\d+\s+(\d+)} [exec free] -> meminf}; if {[string is digit $meminf]} {set meminf [format %.1f [expr $meminf/1024.0]]} {set meminf "n/a"; catch {set meminf [lindex [lindex [split [exec vmstat] \n] 2] 4]}; if {[string is digit $meminf]} {set meminf [format %.1f [expr $meminf/1024.0]]} {set meminf "n/a"}}
set omesto "n/a"; catch {set omesto [format %.1f [expr [exec ps -orss= -p [pid]]/1024.0]]}
set dmesto "n/a"; catch {set dmesto [format %.f [expr {[lindex [split [exec du -s [exec pwd]]""] 0]} / 1024.0]]}
if {$omesto ne "n/a" && $meminf ne "n/a"} {append lout ",  \002$omesto\002 M  (: \002$meminf\002 M)"}
if {$dmesto ne "n/a"} {append lout ",  \002$dmesto\002    ; "} {append lout "; "}
}
append lout "$lfirst: \002$::handlen\002; : \002[encoding system]\002; : \002[regsub -- {^\.} [expr {[info exists ::env(LANG)] ? "$::env(LANG)" : "n/a"}] {}]\002;  : [xdate [duration [expr [unixtime]-$::uptime]]];  : [xdate [duration [expr [unixtime]-${::server-online}]]]."		                                                                                                                                                                                                                                                                               
put_msg -speed 3 -- $lout
}

}
return 1
}
	
proc notavailable-onchan {} {
upvar 2 out out
importvars [list snick shand schan command]
upvar dnick dnick dchan dchan
if {[onchan $dnick $dchan]} {put_msg [sprintf base #131 $dnick $dchan]; return 1}
return 0
}	
}